<!--- This work is licensed under the Creative Commons Attribution-ShareAlike 2.5 License License. 
To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/2.5/ or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

In order to comply with the attribution clause of the Creative Commons License, 
please do not remove this and the "Developed by Blue Instant" notice

Use this software at your own risk

<rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:title>File Explorer</dc:title>
	<dc:date>2006</dc:date>
	<dc:creator><Agent><dc:title>Laura Arguello and Nahuel Foronda</dc:title></Agent></dc:creator>
	<dc:rights><Agent><dc:title>Laura Arguello and Nahuel Foronda</dc:title></Agent></dc:rights>
	<dc:source rdf:resource="http://www.asfusion.com/projects/fileexplorer" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF>
 --->
 
<cfcomponent name="fileBrowser" access="public" description="Facade for directory and file management. It acceses the session scope">

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="getFiles" output="false" description="Returns the list of files in given path - starting from root path" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>
	
		<cfset var result = session.fileManager.getFiles(arguments.path) />
		
		<cfset result["path"] = arguments.path/>
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<!--- we don't want to show  a message --->
		<cfif result["status"]>
			<cfset result["message"] = ""/>
		</cfif>
		<cfreturn result/>
		
</cffunction>


<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="getDirectories" output="false" description="Returns the list of directories in given path - starting from root path" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>

		<cfset var result = session.fileManager.getDirectories(arguments.path) />
		
		<cfset result["path"] = arguments.path/>
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<!--- we don't want to show  a message --->
		<cfif result["status"]>
			<cfset result["message"] = ""/>
		</cfif>
		<cfreturn result/>

</cffunction>

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="createFolder" output="false" description="Creates a folder under the given path" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>
	<cfargument name="name" required="false" type="string" default=""/>	

		<cfset var result = session.fileManager.createFolder(arguments.path, arguments.name) />

		<cfset result["path"] = arguments.path/>
		<cfset result["name"] = arguments.name/>
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<cfreturn result/>
	
</cffunction>

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="removeFolder" output="false" description="Delete given folder" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>

		<cfset var result = session.fileManager.removeFolder(arguments.path) />
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<cfset result["path"] = arguments.path/>

		<cfreturn result/>
		
</cffunction>

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="renameFolder" output="false" description="Renames a folder"
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>
	<cfargument name="name" required="false" type="string" default=""/>	
	<cfargument name="newname" required="false" type="string" default=""/>	
		
		<cfset var result = session.fileManager.renameFolder(arguments.path, arguments.name, arguments.newname) />

		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<cfset result["path"] = arguments.path />
		<cfset result["name"] = arguments.name/>
		<cfset result["rename"] = arguments.newname/>

		<cfreturn result/>
	
</cffunction>

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="removeFile" output="false" description="Deletes a file" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>
	<cfargument name="name" required="false" type="string" default=""/>	

		<cfset var result = session.fileManager.removeFile(arguments.path, arguments.name) />
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<cfset result["path"] = arguments.path />
		<cfset result["name"] = arguments.name/>

		<cfreturn result/>
</cffunction>

<!--- :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<cffunction name="renameFile" output="false" description="Renames a file" 
					access="remote" returntype="struct">
	<cfargument name="path" required="false" type="string" default=""/>
	<cfargument name="name" required="false" type="string" default=""/>	
	<cfargument name="newname" required="false" type="string" default=""/>
	<cfargument name="lastmodified" required="false" type="string" default=""/>
	<cfargument name="size" required="false" type="string" default=""/>
		
		<cfset var result = session.fileManager.renameFile(arguments.path, arguments.name, arguments.newname) />
		<cfset result["status"] =  javacast("boolean",result["status"] )/>
		<cfset result["path"] = arguments.path/>
		<cfset result["name"] = arguments.name/>
		<cfset result["rename"] = arguments.newname/>
		
		<!--- pass these back so that interface can tell which file was modified (or not) --->
		<cfset result["size"] = arguments.size/>
		<cfset result["lastmodified"] = arguments.lastmodified/>
		
		<cfreturn result/>

</cffunction>

</cfcomponent>